/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 183 by dpavlin, Tue Mar 16 19:59:41 2010 UTC revision 237 by dpavlin, Wed Jan 26 18:56:17 2011 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /bin/sh
2    ### BEGIN INIT INFO
3    # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15  # lxc-watchdog.sh  # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
 #  
 # Dobrica Pavlinusic <dpavlin@rot13.org> 2010-03-15  
 #  
 # this script can be used to start/stop Linux containers  
 # using clever inotify hack to monitor halt/reboot from  
 # Tony Risinger posted to lxc-users mailing list  
16  #  #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 26  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                  on_boot="       "                  boot="-"
59                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61          done          done ) | column -t
62  }  }
63    
64    
# Line 43  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
76    
77            echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79  }  }
80    
81    
# Line 57  setup_inittab() { Line 86  setup_inittab() {
86    
87          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
88          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
89          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
91                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
92                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 66  setup_inittab() { Line 95  setup_inittab() {
95  }  }
96    
97    
98    lxc_log() {
99            echo `date +%Y-%m-%dT%H:%M:%S` $*
100    }
101    
102    
103  lxc_kill() {  lxc_kill() {
104          name=$1          name=$1
105          sig=$2          sig=$2
# Line 75  lxc_kill() { Line 109  lxc_kill() {
109                  lxc-info -n $name                  lxc-info -n $name
110                  exit 1                  exit 1
111          fi          fi
112          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
113          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
114  }  }
115    
116  lxc_stop() {  lxc_stop() {
117            lxc_log "$name stop"
118          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
119          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
120            lxc_log "$name stoped"
121  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
122  }  }
123    
124    
125  lxc_start() {  lxc_start() {
126          name=$1          name=$1
127            rootfs=$(lxc_rootfs $1)
128    
129            if [ ! -e $rootfs ] ; then
130                    echo "ERROR $name rootfs $rootfs not found"
131                    return
132            fi
133    
134          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
135                  echo "$name start"                  lxc_log "$name start"
136                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
137                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
138                  lxc-info  -n $name                  lxc-info  -n $name
139                  echo $name > /var/lib/lxc/${name}/on_boot                  test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
140          fi          fi
141  }  }
142    
# Line 105  rootfs=$(lxc_rootfs $1) Line 147  rootfs=$(lxc_rootfs $1)
147  while true; do  while true; do
148          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
149          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
150            stop_on=1 # init
151            sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
152            if [ "$sulogins" -gt 0 ] ; then
153                    stop_on=`expr $stop_on + $sulogins`
154            fi
155    
156          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
157          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
158    
159                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
160                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
161    
162                  case $runlevel in                  case $runlevel in
163                  N*)                  N*)
164                          # nothing for new boot state                          # nothing for new boot state
165                  ;;                  ;;
166                  ??0)                  ??0)
167                          echo "$name halt"                          lxc_log "$name halt"
168                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
169                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
170                          break                          break
171                  ;;                  ;;
172                  ??6)                  ??6)
173                          echo "$name reboot";                          lxc_log "$name reboot";
174                          lxc-stop -n ${name}                          lxc-stop -n ${name}
175                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
176                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 134  while true; do Line 182  while true; do
182                  ;;                  ;;
183                  esac                  esac
184          else          else
185                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
186          fi          fi
187    
188          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
189          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
190  done  done
191    
192  echo "${name} exited"  lxc_log "$name watchdog exited"
193    
194  }  }
195    
196    
197    usage() {
198            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
199            exit 3
200    }
201    
202  command_on_lxc() {  command_on_lxc() {
203  command=$1  command=$1
204  shift  shift
# Line 157  case "$command" in Line 210  case "$command" in
210  start)  start)
211          lxc_exists $1          lxc_exists $1
212          cleanup_init_scripts $1          cleanup_init_scripts $1
213          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
214          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
215            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
216          lxc_start $1          lxc_start $1
217          ( nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          # give container 5 seconds to start more than one process
218            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
219          ;;          ;;
220  stop|halt)  stop|halt)
221          lxc_exists $1          lxc_exists $1
# Line 172  reload|force-reload|restart|reboot) Line 227  reload|force-reload|restart|reboot)
227  watchdog)  watchdog)
228          lxc_watchdog $1          lxc_watchdog $1
229          ;;          ;;
230    boot)
231            echo $1 > /var/lib/lxc/$1/on_boot
232            ;;
233    disable)
234            echo -n > /var/lib/lxc/$1/on_boot
235            ;;
236  *)  *)
237          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
238          ;;          ;;
239    
240  esac  esac
# Line 182  esac Line 242  esac
242  }  }
243    
244  command=$1  command=$1
245  shift  test -z "$command" && usage
   
246  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
247    shift
248    
249  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
250          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
251                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
252                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
253                            command_on_lxc $command $name
254                    else
255                            echo "# skip $command $name"
256                    fi
257          done          done
258  else  else
259          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.183  
changed lines
  Added in v.237

  ViewVC Help
Powered by ViewVC 1.1.26